/*
    GDSpace - Drive Space component
    Copyright   Bill Wright 2001

    This simple component was created in answer to the problem of getting back
    incorrect values for free disk space with other drive space
    components under various versions of Windows.
    This component is based on a Microsoft document that detailed the
    problems with various versions of Windows and large drives.
    The gds function is based on the sample code in the article.
    This component is being offered as freeware.
*/
//---------------------------------------------------------------------------
#ifndef GetDriveSpaceH
#define GetDriveSpaceH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>

void gds (char *Drive, unsigned __int64 &iFree, unsigned __int64 &iTot);
enum TstrType { tyByte, tyKilo, tyMegs, tyGigs};

//---------------------------------------------------------------------------
class PACKAGE TGetDriveSpace : public TComponent
{
private:
AnsiString FDrive;
AnsiString FstrFree;
AnsiString FstrTot;
double FnumFree;
double FnumTot;
TstrType FstrType;

protected:
  void __fastcall SetDrive(AnsiString ADrive);
  void __fastcall SetAnsiFree(AnsiString AstrFree);
  void __fastcall SetAnsiTot(AnsiString AstrTot);
  void __fastcall SetFree(double AnumFree);
  void __fastcall SetTot(double AnumTot);
  void __fastcall SetType(TstrType AType);

public:
__fastcall TGetDriveSpace(TComponent* Owner);
void __fastcall Execute();

__published:
__property AnsiString Drive = {read=FDrive, write=SetDrive};
__property AnsiString strFree = {read=FstrFree, write=SetAnsiFree};
__property AnsiString strTot = {read=FstrTot, write=SetAnsiTot};
__property double numFree = {read=FnumFree, write=SetFree};
__property double numTot = {read=FnumTot, write=SetTot};
__property TstrType strType = {read=FstrType, write=SetType, nodefault};

};
//---------------------------------------------------------------------------
#endif
